<?php
/**
 * @package		HikaShop for Joomla!
 * @version		1.5.8
 * @author		hikashop.com
 * @copyright	(C) 2010-2012 HIKARI SOFTWARE. All rights reserved.
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php
jimport( 'joomla.plugin.plugin' );
class plgContentHikashopsocial extends JPlugin
{
		var $meta=array();
	function plgContentHikashopsocial( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		if ( (isset($_SERVER['HTTPS']) && !empty($_SERVER['HTTPS']) && (strtolower($_SERVER['HTTPS']) != 'off')) ||
				 (isset($_SERVER['HTTP_X_FORWARDED_PROTO']) && strtolower($_SERVER['HTTP_X_FORWARDED_PROTO']) == 'https') ) {
			$this->https = 's';
		} else {
			$this->https = '';
		}
	}
	function onAfterRender(){
		$app =& Jfactory::getApplication();
		if(!$app->isAdmin() && JRequest::getVar('option')=='com_hikashop' && JRequest::getVar('ctrl')=='product' && JRequest::getVar('task')=='show'){
			$pluginsClass = hikashop_get('class.plugins');
			$plugin = $pluginsClass->getByName('content','hikashopsocial');
			$body = JResponse::getBody();
			if(strpos($body,'{hikashop_social}')){
				if(!isset($plugin->params['position'])){
					$plugin->params['position'] = 0;
					$plugin->params['display_twitter'] = 1;
					$plugin->params['display_fb'] = 1;
					$plugin->params['display_google'] = 1;
					$plugin->params['fb_style'] = 0;
					$plugin->params['fb_faces'] = 1;
					$plugin->params['fb_verb'] = 0;
					$plugin->params['fb_theme'] = 0;
					$plugin->params['fb_font'] = 0;
					$plugin->params['fb_type'] = 0;
					$plugin->params['twitter_count'] = 0;
					$plugin->params['google_size']=2;
					$plugin->params['google_count']=1;
				}
				if($plugin->params['position']==0) $html='<div id="hikashop_social" style="text-align:left;">';
				else if($plugin->params['position']==1 && $plugin->params['width']!=0) $html='<div id="hikashop_social" style="text-align:right; width:'.$plugin->params['width'].'px">';
				else{ $html='<div id="hikashop_social" style="text-align:right; width:100%">'; }
				if($plugin->params['display_twitter']) $html.=$this->_addTwitterButton( $plugin);
				if($plugin->params['display_pinterest']) $html.=$this->_addPinterestButton( $plugin);
				if($plugin->params['display_fb']) $html.=$this->_addFacebookButton( $plugin);
				if(@$plugin->params['display_google']) $html.=$this->_addGoogleButton( $plugin);
				$html.='</div>';
				$body = str_replace('{hikashop_social}',$html,$body);
				if(@$plugin->params['display_google']){
					$mainLang = &JFactory::getLanguage();
					$tag = $mainLang->get('tag');
					if(!in_array($tag,array('zh-CN','zh-TW','en-GB','en-US','pt-BR','pt-PT'))) $tag=strtolower(substr($tag,0,2));
					$lang = '{"lang": "'.$tag.'"}';
					$body=str_replace('</head>', '<script type="text/javascript" src="https://apis.google.com/js/plusone.js">'.$lang.'</script></head>', $body);
				}
				if($plugin->params['display_fb']){
					$body=str_replace('<html ', '<html xmlns:fb="https://www.facebook.com/2008/fbml" xmlns:og="http://ogp.me/ns#" 	', $body);
				}
				if($plugin->params['display_pinterest']){
					$body=str_replace('</head>', '<script type="text/javascript" src="http://assets.pinterest.com/js/pinit.js"></script></head>', $body);
				}
				if(!empty($this->meta)){
					foreach($this->meta as $k => $v){
						if(!strpos($body,$k)){
							$body=str_replace('</head>', $v.'</head>', $body);
						}
					}
				}
				JResponse::setBody($body);
			}
		}
	}
	function _addGoogleButton(&$plugin){
		if($plugin->params['google_count']==1){ $count='count="true"'; }
		else{ $count='count="false"'; }
		$div='<span>';
		if($plugin->params['position']==0){
			if($plugin->params['google_size']==0){ $size='size="standard"'; $div="<span class='hikashop_social_google'>";	}
			if($plugin->params['google_size']==1){ $size='size="small"'; $div="<span class='hikashop_social_google'>";}
			if($plugin->params['google_size']==2){ $size='size="medium"'; $div="<span class='hikashop_social_google'>";}
			if($plugin->params['google_size']==3){ $size='size="tall"'; $div="<span class='hikashop_social_google'>";}
		}else{
			if($plugin->params['google_size']==0){ $size='size="standard"'; $div="<span class='hikashop_social_google_right'>";	}
			if($plugin->params['google_size']==1){ $size='size="small"'; $div="<span class='hikashop_social_google_right'>";}
			if($plugin->params['google_size']==2){ $size='size="medium"'; $div="<span class='hikashop_social_google_right'>";}
			if($plugin->params['google_size']==3){ $size='size="tall"'; $div="<span class='hikashop_social_google_right'>";}
		}
		$html=$div.'<g:plusone '.$size.' '.$count.'></g:plusone></span>';
		return $html;
	}
	function _addPinterestButton(&$plugin){
		$product = $this->_getProductInfo();
		$imageUrl = $this->_getImageURL($product->product_id);
		if($plugin->params['position']==0){
			if($plugin->params['pinterest_display']==0){ $count='horizontal'; $div="<span class='hikashop_social_pinterest'>";}
			if($plugin->params['pinterest_display']==1){ $count='vertical'; $div="<span class='hikashop_social_pinterest'>";}
			if($plugin->params['pinterest_display']==2){ $count='none'; $div="<span class='hikashop_social_pinterest'>";}
		}else{
			if($plugin->params['pinterest_display']==0){ $count='horizontal'; $div="<span class='hikashop_social_pinterest_right'>";}
			if($plugin->params['pinterest_display']==1){ $count='vertical'; $div="<span class='hikashop_social_pinterest_right'>";}
			if($plugin->params['pinterest_display']==2){ $count='none'; $div="<span class='hikashop_social_pinterest_right'>";}
		}
		$html=$div.'<a href="http://pinterest.com/pin/create/button/?url='.hikashop_currentURL().'&media='.$imageUrl.'&description='.htmlspecialchars(strip_tags($product->product_description), ENT_COMPAT,'UTF-8').'" class="pin-it-button" count-layout="'.$count.'"><img border="0" src="http://assets.pinterest.com/images/PinExt.png" title="Pin It" /></a></span>';
		return $html;
	}
	function _addTwitterButton(&$plugin){
		if($plugin->params['position']==0){
			if($plugin->params['twitter_count']==0){ $count='horizontal'; $div="<span class='hikashop_social_tw_horizontal'>"; }
			if($plugin->params['twitter_count']==1){ $count='vertical'; $div="<span class='hikashop_social_tw'>"; }
			if($plugin->params['twitter_count']==2){ $count='none'; $div="<span class='hikashop_social_tw'>"; }
		}else{
			if($plugin->params['twitter_count']==0){ $count='horizontal'; $div="<span class='hikashop_social_tw_horizontal_right'>"; }
			if($plugin->params['twitter_count']==1){ $count='vertical'; $div="<span class='hikashop_social_tw_right'>"; }
			if($plugin->params['twitter_count']==2){ $count='none'; $div="<span class='hikashop_social_tw_right'>"; }
		}

		$message='';
		if(!empty($plugin->params['twitter_text'])){
			$message='data-text="'.$plugin->params['twitter_text'].'"';
		}
		$mention='';
		if(!empty($plugin->params['twitter_mention'])){
			$mention='data-via="'.$plugin->params['twitter_mention'].'"';
		}
		$mainLang = &JFactory::getLanguage();
		$locale=strtolower(substr($mainLang->get('tag'),0,2));
		if($locale=='en') $lang='';
		else if($locale=='fr') $lang='data-lang="fr"';
		else if($locale=='de') $lang='data-lang="de"';
		else if($locale=='es') $lang='data-lang="es"';
		else if($locale=='it') $lang='data-lang="it"';
		else if($locale=='ja') $lang='data-lang="ja"';
		else if($locale=='ru') $lang='data-lang="ru"';
		else if($locale=='tr') $lang='data-lang="tr"';
		else if($locale=='ko') $lang='data-lang="ko"';
		else $lang='';
		if (isset($_SERVER['HTTPS']) && !empty($_SERVER['HTTPS']) && (strtolower($_SERVER['HTTPS']) != 'off')) {
			$this->meta['hikashop_twitter_js_code']='<script type="text/javascript">
				function twitterPop(str) {
					mywindow = window.open(\'http://twitter.com/share?url=\'+str,"Tweet_widow","channelmode=no,directories=no,location=no,menubar=no,scrollbars=no,toolbar=no,status=no,width=500,height=375,left=300,top=200");
					mywindow.focus();
				}
				</script>';
	 		$html=$div;
			$html.='<a href="javascript:twitterPop(\''.hikashop_currentURL().'\')"><img src="'.HIKASHOP_IMAGES.'icons/tweet_button.jpg"></a></span>';
			return $html;
		}
		if(!isset($div)) $div='<span>';
		$html=$div;
		$html.='<a href="http'.$this->https.'://twitter.com/share" class="twitter-share-button" '.$message.' data-count="'.$count.'" '.$mention.' '.$lang.'>Tweet</a>
				<script type="text/javascript" src="http'.$this->https.'://platform.twitter.com/widgets.js"></script></span>';
		return $html;
	}
	function _addFacebookButton( &$plugin){
		$options='';
		if($plugin->params['fb_style']==0){ $options='layout=standard&amp;'; $options.='width=400&amp;'; }
		if($plugin->params['fb_style']==1){ $options='layout=button_count&amp;'; $options.='width=115&amp;'; }
		if($plugin->params['fb_style']==2){ $options='layout=box_count&amp;'; $options.='width=115&amp;'; }
		if($plugin->params['fb_faces']==0) $options.='show_faces=false&amp;';
		else $options.='show_faces=true&amp;';
		if($plugin->params['fb_verb']==0) $options.='action=like&amp;';
		else $options.='action=recommend&amp;';
		if($plugin->params['fb_theme']==0) $options.='colorscheme=light&amp;';
		else $options.='colorscheme=dark&amp;';
		if($plugin->params['fb_font']==0) $options.='font=arial&amp;';
		if($plugin->params['fb_font']==1) $options.='font=lucida%2Bgrande&amp;';
		if($plugin->params['fb_font']==2) $options.='font=segoe%2Bui&amp;';
		if($plugin->params['fb_font']==3) $options.='font=tahoma&amp;';
		if($plugin->params['fb_font']==4) $options.='font=trebuchet%2Bms&amp;';
		if($plugin->params['fb_font']==5) $options.='font=verdana&amp;';
		$url=urlencode(hikashop_currentURL());
		if($plugin->params['position']==0){
			if($plugin->params['fb_style']==0){	$sizes='class="hikashop_social_fb_standard"';	$div='<span class="hikashop_social_fb" >';}
			if($plugin->params['fb_style']==1){	$sizes='class="hikashop_social_fb_button_count"'; $div='<span class="hikashop_social_fb" >';}
			if($plugin->params['fb_style']==2){	$sizes='class="hikashop_social_fb_box_count"';	$div='<span class="hikashop_social_fb" >';}
		}else{
			if($plugin->params['fb_style']==0){	$sizes='class="hikashop_social_fb_standard"';	$div='<span class="hikashop_social_fb_right" >';}
			if($plugin->params['fb_style']==1){	$sizes='class="hikashop_social_fb_button_count"'; $div='<span class="hikashop_social_fb_right" >';}
			if($plugin->params['fb_style']==2){	$sizes='class="hikashop_social_fb_box_count"';	$div='<span class="hikashop_social_fb_right" >';}
		}

		if(isset($div)){ $html=$div; }
		else{ $html='';}
		$html.='<iframe
					src="http'.$this->https.'://www.facebook.com/plugins/like.php?href='.$url.'&amp;send=false&amp;'.$options.'height=30"
					scrolling="no"
					frameborder="0"
					style="border:none; overflow:hidden;" '.$sizes.'
					allowTransparency="true">
				</iframe>';
		if(isset($div)) $html.='</span>';
		$product=$this->_getProductInfo();
		$this->meta['property="og:title"']='<meta property="og:title" content="'.htmlspecialchars($product->product_name, ENT_COMPAT,'UTF-8').'"/> ';
		if($plugin->params['fb_type']==0) $this->meta['property="og:type"']='<meta property="og:type" content="product"/> ';
		if($plugin->params['fb_type']==1) $this->meta['property="og:type"']='<meta property="og:type" content="album"/> ';
		if($plugin->params['fb_type']==2) $this->meta['property="og:type"']='<meta property="og:type" content="book"/> ';
		if($plugin->params['fb_type']==3) $this->meta['property="og:type"']='<meta property="og:type" content="company"/> ';
		if($plugin->params['fb_type']==4) $this->meta['property="og:type"']='<meta property="og:type" content="drink"/> ';
		if($plugin->params['fb_type']==5) $this->meta['property="og:type"']='<meta property="og:type" content="game"/> ';
		if($plugin->params['fb_type']==6) $this->meta['property="og:type"']='<meta property="og:type" content="movie"/> ';
		if($plugin->params['fb_type']==7) $this->meta['property="og:type"']='<meta property="og:type" content="song"/> ';
		$config =& hikashop_config();
		$uploadFolder = ltrim(JPath::clean(html_entity_decode($config->get('uploadfolder','media/com_hikashop/upload/'))),DS);
		$uploadFolder = rtrim($uploadFolder,DS).DS;
		$this->uploadFolder_url = str_replace(DS,'/',$uploadFolder);
		$this->uploadFolder = JPATH_ROOT.DS.$uploadFolder;
		$app =& JFactory::getApplication();
		$this->thumbnail = $config->get('thumbnail',1);
		$this->thumbnail_y = $config->get('product_image_y',$config->get('thumbnail_y'));
		$this->thumbnail_x = $config->get('product_image_x',$config->get('thumbnail_x'));
		$this->main_thumbnail_x=$this->thumbnail_x;
		$this->main_thumbnail_y=$this->thumbnail_y;
		$this->main_uploadFolder_url = $this->uploadFolder_url;
		$this->main_uploadFolder = $this->uploadFolder;
		$imageUrl = $this->_getImageURL($product->product_id);
		if(!empty($image)){
			$this->meta['property="og:image"']='<meta property="og:image" content="'.$imageUrl.'" /> ';
		}
		$this->meta['property="og:url"']='<meta property="og:url" content="'.hikashop_currentURL().'" />';
		$conf =& JFactory::getConfig();
		$siteName=$conf->getValue('config.sitename');
		$this->meta['property="og:site_name"']='<meta property="og:site_name" content="'.htmlspecialchars($siteName, ENT_COMPAT,'UTF-8').'"/> ';
		if(!empty($plugin->params['admin'])){
			$this->meta['property="fb:admins"']='<meta property="fb:admins" content="'.htmlspecialchars($plugin->params['admin'], ENT_COMPAT,'UTF-8').'" />'; }
		else{
			return $html;
		}
		$this->meta['property="og:description"']='<meta property="og:description" content="'.htmlspecialchars(strip_tags($product->product_description), ENT_COMPAT,'UTF-8').'"/> ';
		return $html;
	}

	function _getProductInfo(){
		$product_id = (int)hikashop_getCID('product_id');
		$menus	= &JSite::getMenu();
		$menu	= $menus->getActive();
		if(empty($menu)){
			if(!empty($Itemid)){
				$menus->setActive($Itemid);
				$menu	= $menus->getItem($Itemid);
			}
		}
		if(empty($product_id)){
			if (is_object( $menu )) {
				jimport('joomla.html.parameter');
				$category_params = new JParameter( $menu->params );
				$product_id = $category_params->get('product_id');
				JRequest::setVar('product_id',$product_id);
			}
		}
		if(empty($product_id)){
			return;
		}
		$productClass = hikashop_get('class.product');
		$product = $productClass->get($product_id);
		if($product->product_type=='variant'){
			$product = $productClass->get($product->product_parent_id);
		}
		return $product;
	}

	function _getImageURL($product_id){
		$config =& hikashop_config();
		$uploadFolder = ltrim(JPath::clean(html_entity_decode($config->get('uploadfolder','media/com_hikashop/upload/'))),DS);
		$uploadFolder = rtrim($uploadFolder,DS).DS;
		$this->uploadFolder_url = str_replace(DS,'/',$uploadFolder);
		$this->main_uploadFolder_url = $this->uploadFolder_url;
		$db = &JFactory::getDBO();
		$queryImage = 'SELECT * FROM '.hikashop_table('file').' WHERE file_ref_id='.$product_id.'  AND file_type=\'product\' ORDER BY file_ordering ASC, file_id ASC';
		$db->setQuery($queryImage);
		$image = $db->loadObject();
		$imageUrl=JURI::base().$this->main_uploadFolder_url.$image->file_path;
		return $imageUrl;
	}
}